import { Server } from 'socket.io'
import { TSocket } from '../../../../utilities/types'
import { Object } from '@prisma/client'
import ObjectRepository from '../../../../repositories/objectRepository'
import CharacterManager from '../../../../managers/characterManager'

interface IPayload {}

/**
 * Handle game master list object event
 * @param socket
 * @param io
 */
export default function (socket: TSocket, io: Server) {
  socket.on('gm:object:list', async (data: any, callback: (response: Object[]) => void) => {
    const character = CharacterManager.getCharacterFromSocket(socket);
    if (character?.role !== 'gm') {
      console.log(`---Character #${character?.id} is not a game master.`)
      return
    }

    // get all objects
    const objects = await ObjectRepository.getAll()
    callback(objects)
  })
}
